#include <rpc/rpc.h>
#include "offloading_rpc.h"

static struct timeval TIMEOUT = {25, 0};

void remote(CLIENT* clnt, array* input, array* output)
{
	if (clnt_call (clnt, REMOTE_CALL,
		(xdrproc_t) xdr_buffer, (caddr_t)input,
		(xdrproc_t) xdr_buffer, (caddr_t)output, TIMEOUT) != RPC_SUCCESS) 
	{
		output->buf = NULL;
		output->len = 0;
	}
}


CLIENT* client_init(CONST char* addr)
{
	CLIENT* clnt = clnt_create(addr, REMOTE_CALL_PROGRAM, REMOTE_CALL_VERSION, "udp");

	/* Make sure the create worked */
	if (clnt == (CLIENT *) NULL) {
		printf("failed to create client\n");
		return NULL;
	}

	return clnt;
}

void client_finalize(CLIENT* clnt)
{
	clnt_destroy(clnt);
}




