#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "../offloading.h"

struct pair
{
	char* name;
	void* func;
	struct pair* next;
};

static struct pair *head = NULL;
static struct pair *tail = NULL;



static void append_pair(struct pair* new_pair)
{
	if (head == NULL)
	{
		//append the first element
		head = new_pair;
		tail = new_pair;
		new_pair->next = NULL;
	}
	else
	{
		tail->next = new_pair;
		tail = new_pair;
		new_pair->next = NULL;
	}
}


void register_function_and_name(CONST void* CONST function, CONST char* CONST func_name)
{

	struct pair *new_pair = (struct pair*)malloc(sizeof(struct pair));
	if (new_pair == NULL)
	{

		printf("failed to allocate a new pair\n");
		return;
	}

	int func_name_len = strlen(func_name) + 1;
	new_pair->name = (char*)malloc(func_name_len);

	if (new_pair->name == NULL)
	{

		printf("failed to allocate a function name\n");
		free(new_pair);
		return;
	}

	strcpy(new_pair->name, func_name);
	new_pair->func = function;
	
	append_pair(new_pair);
}


CONST char* find_name_by_func_addr(CONST void* CONST function)
{

	struct pair *iterator = head;
	while (iterator != NULL)
	{
		if (iterator->func == function)
		{

			return iterator->name;
		}
		iterator = iterator->next;
	}
	return NULL;
}


CONST void* find_func_by_name(CONST char* CONST func_name)
{
	struct pair *iterator = head;
	while (iterator != NULL)
	{
		if (!strcmp(iterator->name, func_name))
		{

			return iterator->func;
		}
		iterator = iterator->next;
	}
	return NULL;
}

