#include <string.h>
#include "../offloading.h"
#include "offloading_rpc.h"

static int _is_server = 0;

static void register_default_functions()
{
	register_function(marshal_void);
	register_function(unmarshal_void);

	register_function(marshal_char);
	register_function(unmarshal_char);
	
	register_function(marshal_short);
	register_function(unmarshal_short);
	
	register_function(marshal_ushort);
	register_function(unmarshal_ushort);
	
	register_function(marshal_long);
	register_function(unmarshal_long);
	
	register_function(marshal_ulong);
	register_function(unmarshal_ulong);
	
	register_function(marshal_string);
	register_function(unmarshal_string);
}

void init(int* CONST argc, char* argv[])
{
	if (!strcmp("server", argv[*argc-1]))
	{
		_is_server = 1;

		//remove the last cmd-line argument
		argv[*argc-1] = NULL;
		--(*argc);
	}

	register_default_functions();

	if (_is_server)
	{
		server_init();
	}
}






