#ifndef __OFFLOADING_H__
#define __OFFLOADING_H__

#ifdef __cplusplus
//c++ program
#define CONST const
extern "C" {
#else
//c program
#define CONST 
#endif

typedef void (*REMOTE_FUNC)(void* input, void** output);
typedef void (*MARSHAL) (CONST void* CONST obj, char** buf, int* len);
typedef void (*UNMARSHAL) (void** obj, CONST char* buf, int len);

struct offloading_para
{
	void * obj;
	MARSHAL marshal;
	UNMARSHAL unmarshal;
};



void init(int* CONST argc, char* argv[]);
void register_function_and_name(CONST void* CONST function, CONST char* CONST func_name);
CONST char* find_name_by_func_addr(CONST void* function);
CONST void* find_func_by_name(CONST char* CONST func_name);


void remote_call(CONST char* addr, CONST char* CONST func_name, struct offloading_para* ins, struct offloading_para* outs);

#define offload_call(x1, x2, x3, x4) remote_call(x1, #x2, x3, x4)

#define register_function(x) register_function_and_name((CONST void*)x, #x)

void marshal_void (CONST void* CONST obj, char** buf, int* len);
void unmarshal_void (void** obj, CONST char* buf, int len);

void marshal_char (CONST void* CONST obj, char** buf, int* len);
void unmarshal_char (void** obj, CONST char* buf, int len);

void marshal_short (CONST void* CONST obj, char** buf, int* len);
void unmarshal_short (void** obj, CONST char* buf, int len);

void marshal_ushort (CONST void* CONST obj, char** buf, int* len);
void unmarshal_ushort (void** obj, CONST char* buf, int len);

void marshal_int (CONST void* CONST obj, char** buf, int* len);
void unmarshal_int (void** obj, CONST char* buf, int len);

void marshal_uint (CONST void* CONST obj, char** buf, int* len);
void unmarshal_uint (void** obj, CONST char* buf, int len);

void marshal_long (CONST void* CONST obj, char** buf, int* len);
void unmarshal_long (void** obj, CONST char* buf, int len);

void marshal_ulong (CONST void* CONST obj, char** buf, int* len);
void unmarshal_ulong (void** obj, CONST char* buf, int len);

void marshal_string (CONST void* CONST obj, char** buf, int* len);
void unmarshal_string (void** obj, CONST char* buf, int len);

#ifdef __cplusplus
}
#endif

#endif
