#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "../offloading.h"
#include "offloading_rpc.h"


void remote_call(CONST char* addr, CONST char* CONST func_name, struct offloading_para* ins, struct offloading_para* outs)
{
	CLIENT* clnt = client_init(addr);	

	CONST char* unmarshal_in = find_name_by_func_addr(ins->unmarshal);
	CONST char* marshal_out = find_name_by_func_addr(outs->marshal);

	char* obj_buf;
	int obj_len;
	ins->marshal(ins->obj, &obj_buf, &obj_len);

	int total_len = obj_len + strlen(func_name) + strlen(unmarshal_in) + strlen(marshal_out) + 3;

	char* total_buf = (char*)malloc(total_len);
	char* cursor = total_buf;
	
	strcpy(cursor, func_name);
	cursor += strlen(func_name) + 1;
	
	strcpy(cursor, unmarshal_in);
	cursor += strlen(unmarshal_in) + 1;
	
	strcpy(cursor, marshal_out);
	cursor += strlen(marshal_out) + 1;
	
	memcpy(cursor, obj_buf, obj_len);

	array input = {total_buf, total_len};
	array output = {0, 0};
	remote(clnt, &input, &output);

	if (outs->obj != NULL && output.buf != NULL)
	{
		(outs->unmarshal)(outs->obj, output.buf, output.len);
	}

	free(obj_buf);
	free(total_buf);
	free(output.buf);
	client_finalize(clnt);
}


