#include <stdlib.h>
#include <string.h>
#include "../offloading.h"

void marshal_void (CONST void* CONST obj, char** buf, int* len)
{
	*buf = (char*)malloc(1);
	if (*buf != NULL)
    {
        *len = 1;
    }
}

void unmarshal_void (void** obj, CONST char* buf, int len)
{
	*obj = malloc(1);
}

void marshal_char (CONST void* CONST obj, char** buf, int* len)
{
    CONST char* pc = (CONST char*)obj;
    *buf = (char*)malloc(sizeof(char));
    if (*buf != NULL)
    {
        *len = sizeof(char);
		**buf = *pc;
    }
}

void unmarshal_char (void** obj, CONST char* buf, int len)
{
	char* pc = (char*)malloc(sizeof(char));
	*obj = pc;
	if (pc != NULL)
	{
		*pc = *buf;
	}
}


void marshal_short (CONST void* CONST obj, char** buf, int* len)
{
    CONST short* ps = (CONST short*)obj;
    *buf = (char*)malloc(sizeof(short));
    if (*buf != NULL)
    {
        *len = sizeof(short);
		short tmp = htons(*ps);
		memcpy(*buf, &tmp, sizeof(tmp));
    }
}

void unmarshal_short (void** obj, CONST char* buf, int len)
{
	*obj = malloc(sizeof(short));
	if (*obj != NULL)
	{
		short ps = *(short*)buf;
    	ps = ntohs(ps);
    	memcpy(*obj, &ps, sizeof(short));
	}
}

void marshal_ushort (CONST void* CONST obj, char** buf, int* len)
{
    CONST unsigned short* ps = (CONST unsigned short*)obj;
    *buf = (char*)malloc(sizeof(unsigned short));
    if (*buf != NULL)
    {
        *len = sizeof(unsigned short);
		unsigned short tmp = htons(*ps);
		memcpy(*buf, &tmp, sizeof(tmp));
    }
}

void unmarshal_ushort (void** obj, CONST char* buf, int len)
{
	*obj = malloc(sizeof(unsigned short));
	if (*obj != NULL)
	{
		unsigned short ps = *(unsigned short*)buf;
    	ps = ntohs(ps);
    	memcpy(*obj, &ps, sizeof(unsigned short));
	}
}

void marshal_int (CONST void* CONST obj, char** buf, int* len)
{
    CONST int* ps = (CONST int*)obj;
    *buf = (char*)malloc(sizeof(int));
    if (*buf != NULL)
    {
        *len = sizeof(int);
		short tmp = htonl(*ps);
		memcpy(*buf, &tmp, sizeof(tmp));
    }
}

void unmarshal_int (void** obj, CONST char* buf, int len)
{
	*obj = malloc(sizeof(int));
	if (*obj != NULL)
	{
		int ps = *(int*)buf;
    	ps = ntohl(ps);
    	memcpy(*obj, &ps, sizeof(int));
	}
}

void marshal_uint (CONST void* CONST obj, char** buf, int* len)
{
    CONST unsigned int* ps = (CONST unsigned int*)obj;
    *buf = (char*)malloc(sizeof(unsigned int));
    if (*buf != NULL)
    {
        *len = sizeof(unsigned int);
		unsigned int tmp = htonl(*ps);
		memcpy(*buf, &tmp, sizeof(tmp));
    }
}

void unmarshal_uint (void** obj, CONST char* buf, int len)
{
	*obj = malloc(sizeof(unsigned int));
	if (*obj != NULL)
	{
		unsigned int ps = *(unsigned int*)buf;
    	ps = ntohl(ps);
    	memcpy(*obj, &ps, sizeof(unsigned int));
	}
}



void marshal_long (CONST void* CONST obj, char** buf, int* len)
{
    CONST long* ps = (CONST long*)obj;
    *buf = (char*)malloc(sizeof(long));
    if (*buf != NULL)
    {
        *len = sizeof(long);
		long tmp = htonl(*ps);
		memcpy(*buf, &tmp, sizeof(tmp));
    }
}

void unmarshal_long (void** obj, CONST char* buf, int len)
{
    *obj = malloc(sizeof(long));
	if (*obj != NULL)
	{
		long ps = *(long*)buf;
    	ps = ntohl(ps);
    	memcpy(*obj, &ps, sizeof(long));
	}
}


void marshal_ulong (CONST void* CONST obj, char** buf, int* len)
{
    CONST unsigned long* ps = (CONST unsigned long*)obj;
    *buf = (char*)malloc(sizeof(unsigned long));
    if (*buf != NULL)
    {
        *len = sizeof(unsigned long);
		unsigned long tmp = htonl(*ps);
		memcpy(*buf, &tmp, sizeof(tmp));
    }
}

void unmarshal_ulong (void** obj, CONST char* buf, int len)
{
    
	*obj = malloc(sizeof(unsigned long));
	if (*obj != NULL)
	{
		unsigned long ps = *(unsigned long*)buf;
    	ps = ntohl(ps);
    	memcpy(obj, &ps, sizeof(unsigned long));
	}
}


void marshal_string (CONST void* CONST obj, char** buf, int* len)
{
    CONST char* ps = (CONST char*)obj;
    int string_len = strlen(ps)+1;
    *buf = (char*)malloc(string_len);
    if (*buf != NULL)
    {
        *len = string_len;
		strcpy(*buf, ps);
    }
}

void unmarshal_string (void** obj, CONST char* buf, int len)
{
    *obj = malloc(strlen(buf) + 1);
	if (*obj != NULL)
	{
		strcpy(*obj, buf);
	}
}


